#include "Map.h"

float TileGroup::FADE_TIME=0.3;
uint8_t TileGroup::FADE_AMT=160;

void TileGroup::InsertTile(TileRenderData tile){
	if(tiles.size()==0){
		range={tile.pos,{24,24}};
		minX=tile.pos.x;
		maxX=minX+24;
		minY=tile.pos.y;
		maxY=minY+24;
	} else {
		if(tile.pos.x<minX){
			minX=tile.pos.x;
		}
		if(tile.pos.x+24>maxX){
			maxX=tile.pos.x+24;
		}
		if(tile.pos.y<minY){
			minY=tile.pos.y;
		}
		if(tile.pos.y+24>maxY){
			maxY=tile.pos.y+24;
		}
		range={{minX,minY},{maxX-minX,maxY-minY}};
	}
	tiles.push_back(tile);
}

geom2d::rect<int>TileGroup::GetRange(){
	return range;
}

geom2d::rect<int>TileGroup::GetFadeRange(){
	return {range.pos+vi2d{-24,-24},range.size+vi2d{48,48}};
}

std::vector<TileRenderData>&TileGroup::GetTiles(){
	return tiles;
}